using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Mall.Model.Entity.Miai;
using Mall.Model.Extend.Miai;

namespace Mall.Repository.Miai
{
    public class RB_MiAi_BaseInfoRepository : BaseRepository<RB_MiAi_BaseInfo>
    {
        /// <summary>
        /// 表名称
        /// </summary>
        public string TableName { get { return nameof(RB_MiAi_BaseInfo); } }

        /// <summary>
        /// 获取列表
        /// </summary>
        /// <param name="where"></param>
        /// <returns></returns>
        public List<RB_MiAi_BaseInfo_Extend> GetBaseInfoList(RB_MiAi_BaseInfo_Extend where)
        {
            StringBuilder sb = new StringBuilder();
            sb.Append($@"SELECT * from RB_MiAi_BaseInfo  where Status=0");
            if (where != null)
            {
                if (where.TenantId > 0)
                {
                    sb.AppendFormat(" and TenantId={0}", where.TenantId);
                }
                if (where.MallBaseId > 0)
                {
                    sb.AppendFormat(" and MallBaseId={0}", where.MallBaseId);
                }
                if (where.Id > 0)
                {
                    sb.AppendFormat(" and Id={0}", where.Id);
                }
                if (where.UserId > 0)
                {
                    sb.AppendFormat(" and UserId={0}", where.UserId);
                }
            }
            return Get<RB_MiAi_BaseInfo_Extend>(sb.ToString()).ToList();
        }




        /// <summary>
        /// 分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="rowsCount"></param>
        /// <param name="where"></param>
        /// <returns></returns>
        public List<RB_MiAi_BaseInfo_Extend> GetBaseInfoPageList(int pageIndex, int pageSize, out long rowsCount, RB_MiAi_BaseInfo_Extend where)
        {
            StringBuilder sb = new StringBuilder();
            sb.Append($@"SELECT a.*,b.`Name`,b.Photo from RB_MiAi_BaseInfo  as a LEFT JOIN rb_member_user as b on a.UserId=b.Id  where Status=0 and  b.Blacklist!=1");
            if (where != null)
            {
                if (where.TenantId > 0)
                {
                    sb.AppendFormat(" and a.TenantId={0}", where.TenantId);
                }
                if (where.MallBaseId > 0)
                {
                    sb.AppendFormat(" and a.MallBaseId={0}", where.MallBaseId);
                }
                if (where.Id > 0)
                {
                    sb.AppendFormat(" and a.Id={0}", where.Id);
                }
                if (where.UserId > 0)
                {
                    sb.AppendFormat(" and a.UserId={0}", where.UserId);
                }
                if (!string.IsNullOrWhiteSpace(where.RealName))
                {
                    sb.AppendFormat(" and a.RealName like'%{0}%'", where.RealName);
                }
                if (!string.IsNullOrWhiteSpace(where.Name))
                {
                    sb.AppendFormat(" and b.Name like'%{0}%'", where.Name);
                }
            }
            return GetPage<RB_MiAi_BaseInfo_Extend>(pageIndex, pageSize, out rowsCount, sb.ToString()).ToList();
        }




        /// <summary>
        /// 分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="rowsCount"></param>
        /// <param name="where"></param>
        /// <returns></returns>
        public List<RB_MiAi_BaseInfo_Extend> GetFirstBaseInfoPageList(int pageIndex, int pageSize, out long rowsCount, RB_MiAi_BaseInfo_Extend where)
        {
            StringBuilder sb = new StringBuilder();
            sb.Append($@"SELECT a.*,b.`Name`,b.Photo ,(YEAR (curdate())- YEAR ( a.Birthday )- 1+ (DATE_FORMAT(  a.Birthday, '%m%d' )<=(DATE_FORMAT( curdate(), '%m%d' )))) Age   from RB_MiAi_BaseInfo as a
LEFT JOIN rb_member_user as b on a.UserId=b.Id   where a.Status=0 and b.Blacklist!=1 ");
            if (where != null)
            {
                if (where.TenantId > 0)
                {
                    sb.AppendFormat(" and a.TenantId={0}", where.TenantId);
                }
                if (where.MallBaseId > 0)
                {
                    sb.AppendFormat(" and a.MallBaseId={0}", where.MallBaseId);
                }
                if (where.Id > 0)
                {
                    sb.AppendFormat(" and a.Id={0}", where.Id);
                }
                if (where.UserId > 0)
                {
                    sb.AppendFormat(" and a.UserId !={0}", where.UserId);
                }
                if (where.Sex > 0)
                {
                    sb.AppendFormat(" and a.Sex !={0}", where.Sex);
                }
                if (!string.IsNullOrWhiteSpace(where.UserIds))
                {
                    sb.AppendFormat(" and a.UserId in({0})", where.UserIds);
                }

                if (where.Sort == 1)
                {
                    // sb.AppendFormat("  order by ");
                }
                else if (where.Sort == 2)
                {

                    sb.AppendFormat($@" ORDER BY (((a.FollowNum* {where.FollowRate})+(a.BrowseNum*{where.BrowseRate}))) desc");
                }
                else if (where.Sort == 3)
                {
                    sb.AppendFormat(" ORDER BY b.CreateDate desc ");
                }
            }
            return GetPage<RB_MiAi_BaseInfo_Extend>(pageIndex, pageSize, out rowsCount, sb.ToString()).ToList();
        }









        /// <summary>
        /// 分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="rowsCount"></param>
        /// <param name="where"></param>
        /// <returns></returns>
        public List<RB_MiAi_BaseInfo_Extend> GetFirstBaseInfoList(RB_MiAi_BaseInfo_Extend where)
        {
            StringBuilder sb = new StringBuilder();
            sb.Append($@"SELECT a.*,b.`Name`,b.Photo ,(YEAR (curdate())- YEAR ( a.Birthday )- 1+ (DATE_FORMAT(  a.Birthday, '%m%d' )<=(DATE_FORMAT( curdate(), '%m%d' )))) Age    from RB_MiAi_BaseInfo as a
LEFT JOIN rb_member_user as b on a.UserId=b.Id   where a.Status=0 and b.Blacklist!=1 ");
            if (where != null)
            {
                if (where.TenantId > 0)
                {
                    sb.AppendFormat(" and a.TenantId={0}", where.TenantId);
                }
                if (where.MallBaseId > 0)
                {
                    sb.AppendFormat(" and a.MallBaseId={0}", where.MallBaseId);
                }
                if (where.Id > 0)
                {
                    sb.AppendFormat(" and a.Id={0}", where.Id);
                }
                if (where.UserId > 0)
                {
                    sb.AppendFormat(" and a.UserId !={0}", where.UserId);
                }
                if (where.Sex > 0)
                {
                    sb.AppendFormat(" and a.Sex !={0}", where.Sex);
                }

                if (!string.IsNullOrWhiteSpace(where.UserIds))
                {
                    sb.AppendFormat(" and a.UserId in({0})", where.UserIds);
                }

                if (where.Sort == 1)
                {
                    // sb.AppendFormat("  order by ");
                }
                else if (where.Sort == 2)
                {

                    sb.AppendFormat($@" ORDER BY (((a.FollowNum* {where.FollowRate})+(a.BrowseNum*{where.BrowseRate}))) desc");
                }
                else if (where.Sort == 3)
                {
                    sb.AppendFormat(" ORDER BY b.CreateDate desc ");
                }
            }
            return Get<RB_MiAi_BaseInfo_Extend>(sb.ToString()).ToList();
        }




        /// <summary>
        /// 首页插件匹配分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="rowsCount"></param>
        /// <param name="where"></param>
        /// <returns></returns>
        public List<RB_MiAi_BaseInfo_Extend> GetMatchingBaseInfoList(RB_MiAi_BaseInfo_Extend where,int  Top)
        {
            StringBuilder sb = new StringBuilder();
            sb.Append($@"SELECT
   a. *,b.`Name`,b.Photo ,(YEAR (curdate())- YEAR ( a.Birthday )- 1+ (DATE_FORMAT(  a.Birthday, '%m%d' )<=(DATE_FORMAT( curdate(), '%m%d' )))) Age
FROM
    `RB_MiAi_BaseInfo` AS a
JOIN (
    SELECT
        ROUND(
            RAND() * (
                (SELECT MAX(id) FROM `RB_MiAi_BaseInfo`) - (SELECT MIN(id) FROM `RB_MiAi_BaseInfo`)
            ) + (SELECT MIN(id) FROM `RB_MiAi_BaseInfo`)
        ) AS id
) AS t2
LEFT JOIN rb_member_user as b on a.UserId=b.Id  
WHERE
    a.id >= t2.id and a.Status=0 and b.Blacklist!=1
ORDER BY
    a.id
LIMIT {Top} ");
            if (where != null)
            {
                if (where.TenantId > 0)
                {
                    sb.AppendFormat(" and a.TenantId={0}", where.TenantId);
                }
                if (where.MallBaseId > 0)
                {
                    sb.AppendFormat(" and a.MallBaseId={0}", where.MallBaseId);
                }
                if (where.Id > 0)
                {
                    sb.AppendFormat(" and a.Id={0}", where.Id);
                }
                if (where.UserId > 0)
                {
                    sb.AppendFormat(" and a.UserId!={0}", where.UserId);
                }
                if (where.Sex > 0)
                {
                    sb.AppendFormat(" and a.Sex!={0}", where.Sex);
                }
                if (!string.IsNullOrWhiteSpace(where.UserIds))
                {
                    sb.AppendFormat(" and a.UserId in({0})", where.UserIds);
                }
            }
            return Get<RB_MiAi_BaseInfo_Extend>(sb.ToString()).ToList();
        }
    }
}
